<template>
  <div class="article row">
    <div class="article__user-panel gt-xs">
      <img src="avatars/avatar.png" alt="" class="article__avatar q-mb-sm" />
      <div
        @click="!isLiked ? like() : ''"
        :class="{ article__likes_liked: props.isLiked }"
        class="article__likes column justify-center items-center cursor-pointer non-selectable"
      >
        <img src="~assets/svg/like.svg" alt="" />
        <span class="text-h4">{{ props.likes === undefined ? 12 : props.likes }}</span>
      </div>
    </div>
    <div class="article__content col relative-position">
      <div class="article__content-arrow absolute gt-xs"></div>
      <div class="article__categories q-px-md row">
        <span
          :key="index"
          v-for="(category, index) in props.categories"
          class="article__content-category text-subtitle1 q-mr-xs"
        >
          {{ category }}
        </span>
      </div>

      <q-img
        v-if="props.img_path || props.imgPreview"
        class="full-width article__img cursor-pointer"
        :src="props.imgPreview ? props.imgPreview : `http://localhost:3000/${props.img_path}`"
        alt="no way"
        @click="props.slug ? $router.push({ name: 'Article', params: { slug: props.slug } }) : ''"
      />
      <h2
        @click="props.slug ? $router.push({ name: 'Article', params: { slug: props.slug } }) : ''"
        class="q-px-md text-h2 text-capitalize article__title cursor-pointer"
      >
        {{ props.title }}
      </h2>
      <p style="color: #9fa1a8" class="q-px-md text-body1 article__description">
        {{ props.description }}
      </p>
    </div>
  </div>
</template>

<script setup>
const emit = defineEmits(["like"]);
const props = defineProps({
  imgPreview: { type: null, required: false },
  img_path: { type: null, required: false },
  description: { type: String, required: true },
  title: { type: String, required: true },
  categories: { type: Array, required: true },
  likes: { type: Number, required: false },
  slug: { type: String, required: false },
  isLiked: { type: Boolean, required: false },
});
function like() {
  emit("like");
}
</script>

<style lang="scss" scoped>
.article {
  &__user-panel {
    width: 125px;
  }
  &__avatar {
    width: 80px;
    height: 80px;
    border-radius: 8px;
  }
  &__likes {
    border: 2px grey solid;
    border-radius: 8px;
    width: 80px;
    height: 80px;
    color: #d8d9df;
    &_liked {
      background-color: rgba(255, 255, 255, 0.1);
      border-color: #fec367;
    }
  }
  &__content {
    background-color: #2e3138;
    padding-top: 24px;
    padding-bottom: 34px;
    border-radius: 8px;
  }
  &__content-arrow {
    right: 100%;
    top: 20px;

    width: 0;
    height: 0;
    border-top: 20px solid transparent;
    border-bottom: 20px solid transparent;

    border-right: 25px solid #2e3138;
  }
  &__img {
    margin-bottom: 11px;
  }
  &__title {
    margin-bottom: 6px;
  }
  &__categories {
    margin-bottom: 27px;
  }
}
</style>
